/*
    Copyright (C) 2004 Manuel Lausch

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by        
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.                                         

    This program is distributed in the hope that it will be useful,             
    but WITHOUT ANY WARRANTY; without even the implied warranty of              
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.                                
                                                                                
    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software                 
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA   

    Manuel Lausch
    Rudolfstr. 9
    75177 Pfohrzheim
    GERMANY
    software@manuellausch.de
*/

#include <iostream>
#include <stdlib.h>
#include "snake.h"

#ifdef _WIN32
 #include <SDL.h>
#else
 #include <SDL/SDL.h>
#endif

#include "DrawPixel.h"



using namespace std;

#define size 10

void zeichnen( SDL_Surface *display, unsigned short int x, unsigned short int y, unsigned short int r, unsigned short int g, unsigned short int b)
{
	SDL_Rect drect;

	for(int i = 1; i < size; i++)
	{
		for(int j = 1; j < size; j++)
		{
			DrawPixel(display, x*size+i, y*size+j, (char)r, (char)g, (char)b);
		}
	}

	drect.x = x*size;
	drect.y = y*size;
	drect.w = size;
	drect.h = size;

	SDL_UpdateRects(display, 1, &drect);
}

int main(int argc, char* argv[] )
{

	status status;
	snake game;
	int ende, taste;
	SDL_Surface *display;
	SDL_Event event;


	if (SDL_Init(SDL_INIT_VIDEO) < 0)
	{
		cout << "SDL Konnte nicht initialisiert werden:  " << SDL_GetError() << endl;
		exit(-1);
	}

	atexit(SDL_Quit);

	SDL_WM_SetCaption("Punkte: 0", NULL);

	display = SDL_SetVideoMode(size*50+1, size*50+1, 16, SDL_SWSURFACE);
	if (display == NULL)
	{
		cout << "Video Mode konnte nicht initialisiert werden:  " << SDL_GetError() << endl;
		exit(-1);
	}


	for (int i = 0; i <= 49; i++)
	{
		for(int j = 0; j <= 49; j++)
		{
			status = game.read_pixel((unsigned short int) i, (unsigned short int) j);
			switch (status.type)
			{
				case 0:
					zeichnen(display, i, j, 0, 0, 0);
				break;

				case 1:
					zeichnen(display, i, j, 255, 255, 255);
				break;

				case 2:
					zeichnen(display, i, j, 128, 128, 128);
				break;

				case 3:
					zeichnen(display, i, j, 0, 255, 0);
				break;
			}
		}
	}

	SDL_Flip(display);

	ende = 0;
	while (ende == 0)
	{
		 while (SDL_PollEvent(&event))
		 {
		 	switch(event.type)

			{
				case SDL_KEYDOWN:
					taste = event.key.keysym.sym;
				break;

				case SDL_QUIT:
					ende = 1;
				break;
			}
		}

		switch (taste)
		{
			case 273:
				status = game.schritt(1);
			break;

			case 275:
				status = game.schritt(2);
			break;

			case 274:
				status = game.schritt(3);
			break;

			case 276:
				status = game.schritt(4);
			break;

			default:
				status = game.schritt();
			break;
		}
		zeichnen(display, status.xe, status.ye, 0, 0, 0);
		zeichnen(display, status.xa, status.ya, 0,0,255);


		if (status.type == 3)
		{
			status = game.get_punkt();

			zeichnen(display, status.PX, status.PY, 0, 255, 0);


			char titel[12];
			sprintf(titel,"Punkte: %d", game.get_punkte());
			SDL_WM_SetCaption(titel, NULL);
		}
		else
		{
			if (status.type == 2 || status.type == 1)
				ende = 1;
		}

		SDL_Delay(50);
	}
	zeichnen(display, status.xa, status.ya, 255, 0, 0);
	SDL_Delay(5000);
	return 0;
}

