/*
    Copyright (C) 2004 Manuel Lausch

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by        
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.                                         

    This program is distributed in the hope that it will be useful,             
    but WITHOUT ANY WARRANTY; without even the implied warranty of              
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.                                
                                                                                
    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software                 
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA   

    Manuel Lausch
    Rudolfstr. 9
    75177 Pfohrzheim
    GERMANY
    software@manuellausch.de
*/


#include <time.h>
#include <stdlib.h>

struct status
{
	signed short int xe;
	signed short int ye;

	unsigned short int xa;
	unsigned short int ya;

	unsigned short int PX;
	unsigned short int PY;

	unsigned short int type;
};



class snake
{
protected:
	unsigned short int default_richtung;
	short int x, y;
	unsigned short int feld[50][50];
	unsigned short int koordinaten[2501][2];
	unsigned int snake_anfang;
	unsigned int snake_ende;

	unsigned short int PX;
	unsigned short int PY;

	unsigned int punkte;

	void generate_punkt();

public:
	snake();
	status schritt(int richtung = 0);
	status get_punkt();
	unsigned int get_punkte();
	status read_pixel(unsigned short int x, unsigned short int y);
};




void snake::generate_punkt()
{

	do
	{
		PX = (unsigned short int) (rand() % 50);
		PY = (unsigned short int) (rand() % 50);
	} while (feld[PX][PY] != 0);
	
	feld[PX][PY] = 3;
}


snake::snake()
{
	srand(time(0));

	for (int i = 0; i <= 49; i++)
	{
		for(int j = 0; j <= 49; j++)
		{
			feld[i][j] = 0;
		}
	}

	feld[1][1] = 2;
	feld[1][2] = 2;

	punkte = 0;

	x = 1;
	y = 2;
	default_richtung = 3;
	snake_anfang = 1;
	snake_ende = 0;

	koordinaten[0][0] = 1;
	koordinaten[0][1] = 1;
	koordinaten[1][0] = 1;
	koordinaten[1][1] = 2;

	generate_punkt();
}



unsigned int snake::get_punkte()
{
	return punkte;
}

status snake::get_punkt()
{
	status punkt;

	punkt.PX = PX;
	punkt.PY = PY;

	return punkt;
}

status snake::schritt(int richtung)
{
	status change;



	if ((richtung == 1 && default_richtung != 3) || (richtung == 2 && default_richtung != 4) || (richtung == 3 && default_richtung != 1) || (richtung == 4 && default_richtung != 2)) default_richtung = richtung;

	switch (default_richtung)
	{
		case 1:
			y--;
			if (y == -1) y = 49;
		break;

		case 2:
			x++;
			if (x == 50) x = 0;
		break;

		case 3:
			y++;
			if (y == 50) y = 0;
		break;

		case 4:
			x--;
			if (x == -1) x = 49;
		break;
	}

	change.xa = x;
	change.ya = y;



	if (feld[x][y] == 3)
	{
		change.xe = koordinaten[snake_ende][0];
		change.ye = koordinaten[snake_ende][1];

		generate_punkt();
		punkte++;
	}
	else
	{
		change.xe = koordinaten[snake_ende][0];
		change.ye = koordinaten[snake_ende][1];
		feld[koordinaten[snake_ende][0]][koordinaten[snake_ende][1]] = 0;
		snake_ende++;
		if (snake_ende > 2500) snake_ende = 0;
	}


	snake_anfang++;
	if (snake_anfang > 2500) snake_anfang = 0;
	koordinaten[snake_anfang][0] = x;
	koordinaten[snake_anfang][1] = y;

	change.type = feld[x][y];

	feld[x][y] = 2;

	return change;
}

status snake::read_pixel(unsigned short int x, unsigned short int y)
{
	status pixel;
	pixel.type = feld[x][y];

	return pixel;
}
